	; Adventure Vision
	; * RLE Decompressor
	; | 28 Bytes - Main code
	; | 10 Bytes - Table code
	; by JustBurn, Feb 24 2013

.set	TC_PTR, 22

	; @22 = Table code PC[7~0]
	; @23 = Table code PC[11~8]
	; r6  = Number of bytes
	; r7  = Output address
decompress_rle:
	sel	rb0
	mov	a, psw
	mov	r2, a		; Backup PSW to r2
	mov	r1, 30		; User registers start from rb0:r4
	mov	a, @r1
	mov	r6, a		; Get num of packets
	inc	r1
	mov	a, @r1
	mov	r1, a		; Get output address
	clr	a
	mov	r7, a		; index=0
decompress_rle_l1:
	clr	a
	mov	psw, a		; stack=0, ret gets stack 7
	mov	a, r7
	inc	r7		; a = index++
	ret			; Read 2 bytes from tc (counter+data)
decompress_rle_return:
	inc	r7		; index++ again
decompress_rle_l2:
	movx	@r1, a		; Write to output
	inc	r1
	djnz	r5, decompress_rle_l2
	djnz	r6, decompress_rle_l1
	mov	a, r2
	mov	psw, a		; Restore PSW from r2
	sel	rb1
	ret
